/// <reference types="node" />
import { FileTransformer } from "builder-util/out/fs";
import { Stats } from "fs-extra-p";
import { FileMatcher } from "../fileMatcher";
import { Packager } from "../packager";
export interface FileSet {
    src: string;
    destination: string;
    files: Array<string>;
    metadata: Map<string, Stats>;
    transformedFiles: Array<string | Buffer | true | null>;
}
export declare function computeFileSets(matchers: Array<FileMatcher>, transformer: FileTransformer, packager: Packager, isElectronCompile: boolean): Promise<Array<FileSet>>;
export declare function ensureEndSlash(s: string): string;
